#include <Windows.h>
#include <Condmgre.h>
#include <stdio.h>
#include <direct.h>
#include <process.h>
#include <stdlib.h>
#include <ctype.h>
#include <windef.h>
#include <unistd.h>

typedef int (WINAPI *CmGetCorePathPtr)(TCHAR *pPath, int *piSize);

int main(int argc, char **argv)
{
    int result = 0;
    char    conduitExecutable[_MAX_PATH];
    char *arguments[20];
    int i;

    /* Get the current working directory: */
    if( _getcwd( conduitExecutable, _MAX_PATH ) == NULL ) {
	fprintf(stderr, "_getcwd error" );
	result = 3;
    }
    else {
	strcat(conduitExecutable, "\\ConduitInstall.exe");
//	  arguments[0] = conduitExecutable;
	    arguments[0] = malloc(strlen(conduitExecutable)+3);
	    strcpy(arguments[0], "\"");
	    strcat(arguments[0], conduitExecutable);
	    strcat(arguments[0], "\"");

	for(i=1; i<argc; i++) {
	    arguments[i] = malloc(strlen(argv[i])+3);
	    strcpy(arguments[i], "\"");
	    strcat(arguments[i], argv[i]);
	    strcat(arguments[i], "\"");
	}
	arguments[argc] = NULL;
    }

    if (LoadLibrary("Condmgr.dll"))
	printf("loaded library using normal path\n");
    else {
	HINSTANCE lib;

	printf("didnt find library in normal path\n");

	if ((lib = LoadLibrary(".\\CondMgr\\CondMgr.dll")) != NULL) {
	    char    buffer[512];
	    int     size = sizeof(buffer);
	    CmGetCorePathPtr corePathFunc;
	    printf("loaded my version of condmgr\n");
	    corePathFunc = (CmGetCorePathPtr) GetProcAddress(lib, "CmGetCorePath");
	    if (corePathFunc) {
		if ((*corePathFunc)(buffer, &size) == 0) {
		    HINSTANCE full;
		    char    fullPathnameConduitMgr[512];
		    printf("path = \"%s\"\n", buffer);
		    FreeLibrary(lib);
		    strcpy(fullPathnameConduitMgr, buffer);
		    strcat(fullPathnameConduitMgr, "\\CondMgr.dll");
		    full = LoadLibrary(fullPathnameConduitMgr);

		    if (full != NULL) {
			printf("Found %s\n", fullPathnameConduitMgr);
			FreeLibrary(full);
			result = _chdir(buffer);
		    } else {
			printf("must use our conduit mgr\n");
			result = _chdir(".\\CondMgr");
		    }
		}
	    } else {
		fprintf(stderr, "couldn't load CmGetCorePath\n");
		result = 1;
	    }
	} else {
	    fprintf(stderr, "Couldn't load .\\CondMgr\\CondMgr.dll\n");
	    result = 2;
	}
    }
    if (result == 0) {
	int pid;
	// we found a library and we've changed directories,
	// if necessary
	fprintf(stderr, "running %s\n", conduitExecutable);
	fprintf(stderr, "argv[0]: %s\n", arguments[0]);
	fprintf(stderr, "argv[1]: %s\n", arguments[1]);

//	  pid = fork();
//	  if (pid) {
	    // child
//	      result = execv(conduitExecutable, arguments);
	    result = spawnv(P_WAIT, conduitExecutable, arguments);
	    if (result != 0) {
		fprintf(stderr, "Calling ConduitInstall failed\n");
//		  fprintf(stderr, "errno = %d\n", errno);
	    }
//	  } else if (pid<0) {
//		  fprintf(stderr, "fork() failed\n");
//	  } else {
//	      wait(NULL);
//	  }

//	  result = system(conduitExecutable);

    }

    for(i=1; i<argc; i++) {
	free(arguments[i]);
    }

    printf("Hit the any key to continue\n");
    getchar();

    return result;
}

